/*

Copyright 2011 Danilo Gemoli <nylus77@libero.it>

This file is part of Snake_v1.0.

Snake_v1.0 is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Snake_v1.0 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Snake_v1.0.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include "cibo.h"

extern int tras_rig;
extern int tras_col;

void genera_cibo( Area& area, bool cibo_diversificato )
{
	srand( time( 0 ) );

	int riga;
	int colonna;
	int tot_righe = area.get_righe();
	int tot_colonne = area.get_colonne();

	do
	{
		riga = rand() % tot_righe;
		colonna = rand() % tot_colonne;
	}
	while( area.get_posizione( riga, colonna ) != 0 );

	static int tot_mele = 1, tot_kiwi = 1;

	if( cibo_diversificato )
	{

		if( tot_mele % 4 == 0 )
		{
			Kiwi k;
			attron( COLOR_PAIR( 6 ) );
			mvprintw( riga + tras_rig, colonna + tras_col, k.get_simbolo().c_str() );
			attroff( COLOR_PAIR( 6 ) );
			area.set_posizione( riga, colonna, k.get_valore() );
			++tot_kiwi;
			++tot_mele;
		}
		else
		{
			Mela m;
			attron( COLOR_PAIR( 1 ) );
			mvprintw( riga + tras_rig, colonna + tras_col, m.get_simbolo().c_str() );
			attroff( COLOR_PAIR( 1 ) );
			area.set_posizione( riga, colonna, m.get_valore() );
			++tot_mele;
		}
	}
	else
	{
		Mela m;
		attron( COLOR_PAIR( 1 ) );
		mvprintw( riga + tras_rig, colonna + tras_col, m.get_simbolo().c_str() );
		attroff( COLOR_PAIR( 1 ) );
		area.set_posizione( riga, colonna, m.get_valore() );
	}
}

