/*

Copyright 2011 Danilo Gemoli <nylus77@libero.it>

This file is part of Snake_v1.0.

Snake_v1.0 is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Snake_v1.0 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Snake_v1.0.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef COLLISIONI_H
#define COLLISIONI_H

#include "area.h"
#include "serpente.h"
#include "cibo.h"
#include "punteggio.h"

// QUESTA CLASSE E' ESTENSIBILE : SI POSSONO AGGIUNGERE NUOVE CARATTERISTICHE ALL' AREA DI GIOCO
// ( MAGARI ALTRI OSTACOLI ) IMPLEMENTANDO METODI SOLO DA QUESTA CLASSE E LASCIANDO INVARIATO IL
// RESTO DEL CODICE

enum Ostacoli { MURO = -1, TELETRASPORTO_MURO = -2 };

class Collisioni
{
	public :
		Collisioni();

		bool collisione_muro( Area&, Serpente& ) const;
		bool collisione_cibo( Area&, Serpente& ) const;
		bool collisione_serpente( Area&, Serpente& ) const;
		bool collisione_teletrasporto( Area&, Serpente& ) const;
		
		void gestisci_muro( Area& ) const; 
		const Collisioni& gestisci_teletrasporto_muro( Area&, Serpente& ) const;
		const Collisioni& gestisci_cibo( Area&, Serpente&, Punteggio&, bool ) const;
		void gestisci_serpente( Area& ) const;

};

#endif



