/*

Copyright 2011 Danilo Gemoli <nylus77@libero.it>

This file is part of Snake_v1.0.

Snake_v1.0 is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Snake_v1.0 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Snake_v1.0.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef SERPENTE_H
#define SERPENTE_H

#include "area.h"

class Serpente
{
	public :
		Serpente( int, int, int, int, int, Area& );

		int get_testa_riga() const;
		int get_testa_colonna() const;
		int get_coda_riga() const;
		int get_coda_colonna() const;
		int get_lunghezza() const;
		int get_colore() const;

		Serpente& set_testa_riga( int );
		Serpente& set_testa_colonna( int );
		Serpente& set_coda_riga( int );
		Serpente& set_coda_colonna( int );

		Serpente& muovi_destra( Area& );
		Serpente& muovi_sinistra( Area& );
		Serpente& muovi_su( Area& );
		Serpente& muovi_giu( Area& );

		Serpente& cancella_coda( Area& );
		Serpente& mangia();
		Serpente& aumenta_lunghezza();

	private :
		int testa_riga;
		int testa_colonna;
		int coda_riga;
		int coda_colonna;

		int lunghezza;
		int colore;
		int cibo_da_digerire;
};


#endif
